TypeText	
; this routine types text

;hl contains position of text on screen
;de contains text address in memory
;bc is used		

	;default text color is white on black
	LD A,71
	LD (TextColor),A
		
	LD (TextLineAd),HL
	
Text1	
	;check if end of string
	LD A,(DE)
	OR A
	RET Z ;end of text if zero
	
	CP 63; checks if should go to new line
	JR Z,TextNewLine
	CP 51; checks if color change
	JR Z,TextColorChange
	;letter attribute	
	PUSH HL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,(TextColor)
	LD (HL),A ;load attribute into char
	POP HL
	;draw a letter
	LD A,(DE)	;code of letter loAded
	LD BC,Letters-8;start of Letters sprites
	
	;count Address of letter
	SLA A
	SLA A
	SLA A		;a=a*8 (with carry)to count Adress of letter		
	
	PUSH HL
	LD HL,0
		
	LD L,A
	LD A,0
	ADC A,H	
	LD H,A	;HL=A*8	
	ADD HL,BC
	LD B,H
	LD C,L	;bc loAded with letter sprite address
	POP HL
		
				;Address of printed letter placed in bc
	
Text2		
	PUSH HL
	PUSH DE
	LD E,8
Text3	LD A,(BC)	;read letter data
	LD (HL),A	;and print it in screen		
	INC H
	INC BC	;go to another byte
	DEC E
	JR NZ, Text3
	POP DE
	POP HL

;go to another letter			
	INC L	;next char on the screen
	INC DE ;next letter
	JR Text1
		
TextNewLine
	;this subroutine goes one line down	with text
	LD HL,(TextLineAd)	;beginning of current line in hl
	CALL CountNextLine	;count ADDress of one line down and place it in hl
	LD (TextLineAd),HL	;update value
	INC DE			;next letter
	JR Text1			;go to letter printing routine
TextColorChange
	INC DE
	LD A,(DE);Read new color
	LD (TextColor),A; and write it to proper cell			
	INC DE; go to next letter
	JR Text1
;----
CountNextLine
	;routine takes hl address of screen byte and counts ADDress of byte one line lower
	LD A,L
	ADD A,32
	LD L,A; go to next line
	RET NC; if no next screen segment,just return
		;go to next screen segment if needed
		LD A,H
		ADD A,8
		LD H,A
	RET				
TextColor .BYTE 71; this cell stores text attribute
TextLineAd .WORD 16384;these cells store screen address 
			   ;of currently printed text line (address of 1st char, to be exact)
;------------
DisplayLevelNr
	LD A,(LevelNr)
	ADD A,29
	LD (LevelNrText+2),A
	
	LD DE,LevelNrText
	CALL TypeText
	RET
	
LevelNrText
	.BYTE 51,67,29,0
	
;-------------
DisplayLinesLeft
	LD A,(LinesLeft)
	
	;find number of 10s
	LD B,0
DisplayLinesLeft2
	INC B
	SUB 10
	JR NC,DisplayLinesLeft2
	DEC B ;number of tens in B
	ADD A,10
	
	ADD A,29
	LD (LinesLeftText+3),A; number of 1s
	
	LD A,B
	ADD A,29
	LD (LinesLeftText+2),A; number of 10s
	
	LD HL,18517
	LD DE,LinesLeftText
	CALL TypeText
	RET

LinesLeftText
	.BYTE 51,67,29,29,0
;----------------------

DisplayLevelHeading
;displays info about current level and picture reavealed in it
;nr of level stored in A
	
	CALL ClearScreen
	
;texts 
	;e.g. LEVEL 1
	LD HL,18478
	LD DE,LevelText
	CALL TypeText	

	LD HL,18512
	CALL DisplayLevelNr
	
	;describtion	
	LD A,(LevelNr)
	LD HL,LevelNames-4
	LD DE,4
	
FindDescribtionText
	ADD HL,DE
	DEC A
	JR NZ, FindDescribtionText 	
	
	LD E,(HL)
	INC HL
	LD D,(HL) ;text address in DE
	INC HL
	
	LD C,(HL)
	INC HL
	LD B,(HL)
	LD L,C
	LD H,B ;position in HL
	CALL TypeText
	
	LD B,50
StartLevelDelay
	HALT
	DJNZ StartLevelDelay
	RET

;------------------------
GameMenu
	CALL ClearScreen
	
	LD HL,16519;logo
	LD DE,Logo
	CALL DrawTile
	
	LD HL,16519
	LD B,18
	XOR A
GameMenu2
	LD (HL),A
	INC L
	DJNZ GameMenu2
	
	;texts
	LD HL,18436
	LD DE,MenuText1
	CALL TypeText
	LD HL,18500
	LD DE,MenuText2
	CALL TypeText	
	LD HL,18564
	LD DE,MenuText3
	CALL TypeText
	LD HL,20487
	LD DE,MenuText4
	CALL TypeText
	
	;reading keyborad
GameMenu3
	LD BC,63486
	IN A,(C)
	BIT 0,A;1
	JR Z,ChooseKeyboard
	BIT 1,A;2
	JR Z,ChooseJoystick
	BIT 2,A;3
	JP Z,NewGame
	JR GameMenu3
	
ChooseKeyboard
	CALL ClearLineSound
	XOR A
	LD (PlayerControl),A
	JR GameMenu3
ChooseJoystick
	CALL ClearLineSound
	LD A,1
	LD (PlayerControl),A
	JR GameMenu3
;--------------------
GameWin
	CALL ClearScreen
	
	LD HL,18472
	LD DE,Congrat1Text
	CALL TypeText
	
	LD HL,18529
	LD DE,Congrat2Text
	CALL TypeText

	LD B,200
GameWin2
	HALT
	DJNZ GameWin2
	JP GameMenu
;---------------------
GameOver	
	LD B,3
GameOver2
	PUSH BC
	CALL LevelEndSound
	POP BC
	DJNZ GameOver2
	
	CALL ClearScreen
	LD HL,18506
	LD DE,GameOverText
	CALL TypeText
	
	LD B,200
GameOver3
	HALT
	DJNZ GameOver3
	
	JP GameMenu
	
;------------------	

LevelNames
	.WORD Level1Name
	.WORD 18565
	.WORD Level2Name
	.WORD 18568
	.WORD Level3Name
	.WORD 18572
	.WORD Level4Name
	.WORD 18570
	.WORD Level5Name
	.WORD 18570
	.WORD Level6Name
	.WORD 18571
	.WORD Level7Name
	.WORD 18573
	.WORD Level8Name
	.WORD 18570
	.WORD Level9Name
	.WORD 18566		   			

Letters
	.BYTE	  0, 62,127, 99,127,127, 99, 99;a
	.BYTE	  0,126,127, 99,126, 99,127,126;b
	.BYTE	  0, 62,127, 99, 96, 99,127, 62;c
	.BYTE	  0,126,127, 99, 99, 99,127,126;d
	.BYTE	  0, 63,127, 96,124, 96,127, 63;e
	.BYTE	  0, 63,127, 96,124, 96, 96, 96;f
	.BYTE	  0, 62,127, 96,111, 99,127, 62;g
	.BYTE	  0, 99, 99,127,127, 99, 99, 99;h
	.BYTE	  0,126,126, 24, 24, 24,126,126;i
	.BYTE	  0,127,127, 12, 12, 12,124, 56;j
	.BYTE	  0,102,110,124,120,124,110,103;k
	.BYTE	  0, 96, 96, 96, 96, 96,127,127;l
	.BYTE	  0, 99,119,127,107, 99, 99, 99;m
	.BYTE	  0, 99,115,123,127,111,103, 99;n
	.BYTE	  0, 62,127, 99, 99, 99,127, 62;o
	.BYTE	  0,126,127, 99,127,126, 96, 96;p
	.BYTE	  0, 62,127, 99, 99,101,122, 61;q
	.BYTE	  0,126,127, 99,127,126,103, 99;r
	.BYTE	  0, 62,126,112, 62,  7,127,126;s
	.BYTE	  0,126,126, 24, 24, 24, 24, 24;t
	.BYTE	  0, 99, 99, 99, 99, 99,127, 62;u
	.BYTE	  0, 99, 99, 99,119, 62, 28,  8;v
	.BYTE	  0, 99, 99, 99,107,127,119, 99;w
	.BYTE	  0, 99,119, 62, 28, 62,119, 99;x
	.BYTE	  0, 99, 99,127, 63,  3,127,126;y
	.BYTE	  0,127,127, 14, 28, 56,127,127;z
	.BYTE 	  0,0,0,0,0,0,0,0;space
	.BYTE	  0, 96,108,124,120,112,127,127;



Numbers
	.BYTE	 0,62,127,103,107,115,127, 62;0 (index 29)
	.BYTE	 0,28, 60, 12, 12, 12,127,127;1
	.BYTE	 0,62,127,  7, 62,112,127,127;2
	.BYTE	 0,62,127,  3, 30,  3,127, 62;3
	.BYTE	 0,14, 30, 54,102,127,127,  6;4
	.BYTE	 0,127,127, 96,126,  7,127,126;5
	.BYTE	 0,28, 56, 62,127, 99,127, 62;6
	.BYTE	 0,127,127,  7, 14, 28, 56, 56;7
	.BYTE	 0,62,127, 99, 62, 99,127, 62;8
	.BYTE	 0,62,127, 99,127, 63, 14, 28;9	
	

;-----------Texts----------

LevelText	
	.BYTE 51,69,12,5,22,5,12,0	
LinesText
	.BYTE 51,69,12,9,14,5,19,63,12,5,6,20,0
BlockText
	.BYTE 51,69,14,5,24,20,63,2,12,15,3,11,0 
	
;--names of levels--

Level1Name
	.BYTE 19,8,1,4,15,23,27,15,6,27,20,8,5,27,2,5,1,19,20,27,9,9,63,63,51,65,27,27,27,27,27,27,27,16,19,25,7,14,15,19,9,19,27,0
Level2Name
	.BYTE 27,27,23,9,14,7,19,27,15,6,27,6,21,18,25,63,63,51,65,2,18,15,4,5,18,2,21,14,4,27,19,15,6,23,1,18,5,0
Level3Name
	.BYTE 27,27,9,19,8,1,18,63,63,51,65,19,9,12,13,1,18,9,12,19,0
Level4Name
	.BYTE 12,15,19,20,27,22,9,11,9,14,7,19,63,63,51,65,27,27,9,14,20,5,18,16,12,1,25,0
Level5Name
	.BYTE 13,5,7,1,27,12,15,27,13,1,14,9,1,63,63,27,51,65,9,13,1,7,5,27,23,15,18,11,19,0
Level6Name
	.BYTE 2,12,1,3,11,20,8,15,18,14,5,63,63,51,65,27,9,14,20,5,18,16,12,1,25,0
Level7Name
	.BYTE 20,18,15,10,1,14,63,63,51,65,3,1,16,3,15,13,0
Level8Name
	.BYTE 1,18,3,20,9,3,27,13,15,22,5,19,63,63,51,65,27,27,27,4,9,14,1,13,9,3,0
Level9Name
	.BYTE 3,1,22,5,13,1,14,27,21,7,8,27,15,12,25,13,16,9,3,19,63,63,51,65,27,27,5,12,5,3,20,18,15,14,9,3,27,1,18,20,19,0

Congrat1Text
	.BYTE 51,66, 3,15,14,7,18,1,20,21,12,1,20,9,15,14,19,0
Congrat2Text
	.BYTE 51,70,25,15,21,27,8,1,22,5,27,3,15,13,16,12,5,20,5,4,27,13,15,3,11,1,20,5,20,18,9,19,0
	
GameOverText
	.BYTE 51,69,7,1,13,5,27,15,22,5,18,0

MenuText1
	.BYTE 30,27,11,5,25,2,15,1,18,4,27,17,27,1,27,15,27,16,27,19,16,1,3,5,0
MenuText2
	.BYTE 31,27,11,5,13,16,19,20,15,14,27,10,15,25,19,20,9,3,11,0
MenuText3
	.BYTE 32,27,19,20,1,18,20,27,7,1,13,5,0
MenuText4
	.BYTE 51,65,18,1,6,1,28,27,13,9,1,26,7,1,27,31,29,29,37,0